// This file has been autogenerated from parsing an Objective-C header file added in Xcode.

using System;

using MonoTouch.Foundation;
using MonoTouch.UIKit;
using System.Collections.Generic;

namespace muss
{
	public partial class BlogViewController : UIViewController
	{
		public BlogViewController (IntPtr handle) : base (handle)
		{
		}

		public override void ViewDidLoad ()
		{
			base.ViewDidLoad ();
			Title = "Latest Blog Posts";
			this.NavigationController.NavigationBarHidden = false;

			/**
			 * Populate the list of blog posts
			 **/

			System.Xml.XmlTextReader reader = new System.Xml.XmlTextReader("http://themussblog.com/feed");

			int titleCount = 0;
			List<string> titles = new List<string>();
			List<string> dates = new List<string>();

			while (reader.Read())
			{
				//Console.WriteLine(reader.Name);
				if(reader.Name == "title")
				{
					titleCount++;
					if (titleCount > 2) //not the site title.
						titles.Add(reader.ReadString());
				}
				if(reader.Name == "pubDate")
				{
					string[] date = reader.ReadString().Split(' '); //trim off the timestamp
					string addDate = date[0] + " " + date[1] + " " + date[2] + " " + date[3];
					dates.Add(addDate); 
				}

			}
			postlist.Source = new BlogList(titles, dates, NavigationController);

		}

	}

	//The tablesource
	public class BlogList : UITableViewSource 
	{
		protected List<string> tableItems;
		protected List<string> itemDates;
		protected string cellIdentifier = "TableCell";
		UINavigationController navController;
		public BlogList (List<string> items, List<string> dates, UINavigationController navController)
		{
			this.navController = navController;
			tableItems = items;
			itemDates = dates;
		}
		public override int RowsInSection (UITableView tableview, int section)
		{
			return tableItems.Count;
		}
		public override UITableViewCell GetCell (UITableView tableView, MonoTouch.Foundation.NSIndexPath indexPath)
		{
			// request a recycled cell to save memory
			UITableViewCell cell = tableView.DequeueReusableCell (cellIdentifier);
			// if there are no cells to reuse, create a new one
			if (cell == null)
				cell = new UITableViewCell (UITableViewCellStyle.Subtitle, cellIdentifier);
			cell.TextLabel.Text = tableItems[indexPath.Row];
			cell.DetailTextLabel.Text = itemDates[indexPath.Row];
			return cell;
		}
		public override void RowSelected (UITableView tableView, NSIndexPath indexPath)
		{

			UIStoryboard board = UIStoryboard.FromName ("MainStoryboard", null);
			BlogDetailViewController ctrl = (BlogDetailViewController)board.InstantiateViewController ("BlogDetail");
			ctrl.Title = tableItems[indexPath.Row];
			ctrl.blogTitle = tableItems[indexPath.Row];
			ctrl.date = itemDates[indexPath.Row];

			navController.PushViewController(ctrl, true);
 
			tableView.DeselectRow (indexPath, true); // iOS convention is to remove the highlight
		}
	}
}
